#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/mman.h>
#include <pthread.h>

#include "XVVideo.h"
#include "Videre.h"
#include "XVMacros.h"
#include <iostream>

extern int debug;
static bool complain_flag=true;

template <class T>
int XV_Videre<T>::initiate_acquire(int frame)
{
   return 1;
}

template <class T>
int XV_Videre<T>::wait_for_completion(int frame)
{
   if(!(s_image = sourceObject->GetImage(500))) return 0; // timeout?
   if(!s_image->haveColor)
   {
	   if(complain_flag){
		   complain_flag=false;
		   cerr << "Color is not enabled in config file" << endl;
	   }
	   return 0;
   }
   scalar_image[XVVID_LEFT]->remap((u_char*)s_image->left,false);
   scalar_image[XVVID_RIGHT]->remap((u_char*)s_image->right,false);
   
   if(s_image->haveColor)vid_correct_color(image_buffers[frame],s_image->color);
   return 1;
}

template <class T>
XVImageScalar<u_char>       **XV_Videre<T>::get_stereo(void)
{
   scalar_image[XVVID_LEFT]->remap((u_char*)s_image->left,false);
   scalar_image[XVVID_RIGHT]->remap((u_char*)s_image->right,false);
   return scalar_image;
}

template <class T>
void XV_Videre<T>::close(void)
{
  if(sourceObject) sourceObject->Close();
  sourceObject=NULL;
}

template <class T>
int XV_Videre<T>::open(const char *dev_name)
{
  sourceObject->Open(NULL);
  sourceObject->ReadParams((char *)dev_name);
  sourceObject->Start();
  //sourceObject->SetRect(true);
  return 1;
}

template <class T>
XV_Videre<T>::XV_Videre(const char *dev_name,const char *parm_string):
             XVVideo<T>(dev_name,parm_string)
{
  s_image=NULL;
  sourceObject = (svsAcquireImages *)getVideoObject();
  open(dev_name);
  if(!sourceObject->CheckParams()) 
         sourceObject->ReadParams((char*)parm_string);
  params=sourceObject->GetIP();
  cerr << "Videre: using " << svsVideoIdent << endl;
  scalar_image[XVVID_LEFT]=
  	new XVImageScalar<u_char>(params->width,params->height);
  scalar_image[XVVID_RIGHT]=
  	new XVImageScalar<u_char>(params->width,params->height);
  XVSize size(params->width,params->height);
  init_map(size,1);
}

template <class T>
XV_Videre<T>::~XV_Videre()
{
  close();
}

template class XV_Videre<XVImageRGB<XV_RGB15> >;
template class XV_Videre<XVImageRGB<XV_RGB16> >;
template class XV_Videre<XVImageRGB<XV_RGB24> >;
template class XV_Videre<XVImageRGB<XV_TRGB24> >;
template class XV_Videre<XVImageRGB<XV_RGBA32> >;
template class XV_Videre<XVImageRGB<XV_GLRGBA32> >;
