#include <unistd.h>
#include "svs22b.h"

svsSP svsParams;

/*
 * SVS video capture main functions
 */

char *svsVideoIdent;  // identifier string for this capture interface

int svsDevice1;	// first video capture device
int svsDevice2;	// second video capture device
int svsDeviceName; // name for the default device

char *svsDevName;  /* name of first device */
char *svsDevName2; /* name of second device */
int svsIsPXC_PC104; /* set to 1 for PXC PC104+ board under LINUX */

int svsMeteorMotion; /* set if capturing motion images */
int svsDualCaptureFormat; /* set if line interlace stereo */
int svsSwapInterlace; /* 1 to swap L/R interlaced images */
int svsVideoFormat;	/* fourcc code for video stream type */
int svsVideoBPP;	/* number of bits per pixel, only for RGB */
/* opens capture for business: */
int  svsVideoOpen(svsSP *sp) {return -1;}/* returns -1 if error, 0 if ok */
void svsVideoClose(void) {} /* closes capture */
/* waits for next continuous image from meteors: */
int  svsVideoWaitImage(int ms) {return -1;}
int  svsVideoCheckImage(void) {return 0;} /* Returns 1 if an image is ready */
void svsVideoGetImage(unsigned char **buf, unsigned char **buf2, 
		      unsigned char **color) {}
void svsVideoGetRectImage(unsigned char **left, unsigned char **right, 
			  unsigned char **color, svsSP *sp) {}
int  svsVideoCheckParameters(svsSP *sp) {return -1;}	/* returns -1 on error, 0 if ok */
int  svsVideoStartContinuous(svsSP *sp) {return -1;}	/* ditto */
void svsVideoHaltContinuous(void) {}
int  svsVideoGrabSingle(svsSP *sp, int ms) {return -1;} /* returns -1 on error, 0 if ok ??? */

// Calls to set parameters while streaming video
int svsVideoSetDigParams(svsSP *sp) {return -1;}/* -1  on error, 0 if ok */
int svsVideoSetOffsets(svsSP *sp) {return -1;} /* ditto */

// Imager name (not implemented on analog stereo heads)
int svsVideoGetName(char *name) {return -1;}
int svsVideoSetName(char *name) {return -1;}

// Debugging callbacks
void (*capDebug)(char *str);
void (*svsDebug)(char *str);
void svsDebugMessage(char *str, ...);


/*
 * Calculations
 */

int svsHasMMX = -1;	/* 1 for MMX, 0 for none, -1 for not checked. 
				   Can be set or read */
int svsCheckMMX(void) {return -1;} /* Checks for MMX and sets svsHasMMX */


/* 
 * Puts stereo results in dest, using il and ir images.
 * Uses stereo params structure; if null, defaults to svsParams.
 */
void svsWarpImage(unsigned char *dest, unsigned char *src, int which, svsSP *sp) {}
void svsWarpImageBayer(unsigned char *dest, unsigned char *dest2,
		       unsigned char *src, int which, svsSP *sp) {}
void svsWarpImageMono (unsigned char *dest, unsigned char *src, 
		       int which, svsSP *sp) {}
void svsCalcStereo(short *dest, unsigned char *il, 
		   unsigned char *ir, svsSP *sp) {}
void svsCalcEdges(signed char *ld, signed char *rd, unsigned char *il, 
		  unsigned char *ir, svsSP *sp) {}
void svsCalcConfidence(char *dest, unsigned char *il, svsSP *sp) {}
void svsCalcMotion(unsigned char *dest, unsigned char *il, 
		   unsigned char *ir, int xs, int ys, svsSP *sp) {}


void svsReconstruct3D (float *X, float *Y, float *Z, float x, float y,
		       float disp, svsSP *sp) {}
void svsReconstruct3DFast (float *X, float *Y, float *Z, float x, float y,
			   float disp, svsSP *sp) {}

/*
 * Display functions
 */

int svsStereoOffsetX, svsStereoOffsetY; /* right image offsets */
float svsRangeImageValue(short *im, svsSP *sp) {return 0.0;}
void svsSleep(int ms) {} /* wait this long in milliseconds */
int svsSharedMemory = 0;	/* if we can use shared memory, really only Unix */

#ifdef WIN32
extern HWND svsMainWin;		/* main window handle */
#endif

/*
 * image file I/O
 */

/* Reads an .ssi file and put contents into buffer.  Creates
   buffer if null. */
unsigned char *svsReadFile(char *name, unsigned char *buffer, 
			   int *height, int *width, int *num) {return 0;}
int svsWriteImage(char *name, unsigned char *buf, int width, 
		  int height, char *type, int numframes) {return -1;}
int svsReadFileSizeBMP(char *name, int *width, int *height) {return -1;}
int svsReadFileBMP(char *name, unsigned char *buffer, 
		   int *width, int *height, int interlace) {return -1;}
unsigned char *svsReadFile2BMP(char *name, unsigned char *buffer, 
			       int *width, int *height) {return 0;}
int svsWriteImageBMP(char *name, unsigned char *im, int width, int height, 
		     int isDisparity) {return -1;}
int svsWriteImageColorBMP(char *name, unsigned char *im,
			  int width, int height, int isDisparity) {return -1;}
int svsWrite3DArray(char *fname, float *X, float *Y, float *Z,
		    unsigned char *image, short *disp, int type, svsSP *sp) {return -1;}
int svsWrite3DCloud(char *fname, float *X, float *Y, float *Z,
		    unsigned char *image, short *disp, int type, svsSP *sp,
		    int nump) {return -1;}
int svsWriteDisparity(char *fname, short *disp, svsSP *sp) {return -1;}


char *svsError;
int svsWriteParamFile(char *fname, svsSP *sp) {return -1;}	/* writes out stereo setting */
int svsWriteRectFile(char *fname, svsSP *sp) {return -1;}	/* writes out stereo rectification */
int svsReadParamFile(char *fname, svsSP *sp) {return -1;};	/* reads in stereo setting */

/* version of the software */
int svsEngineVersion;

int svsPreFilterTime, svsPostFilterTime, svsCorrTime, svsMaxTime;

//
// new FLTK-based drawing fns
//

void svsDrawImage(void *w, unsigned char *im, svsSP *p, int type) {}
void *svsGetWindow(int w, int h) {}
int  fltk_check(void) {return -1;}	/* process fltk events */
