#include <config.h>
#include <XVSSD.h>
#include <XVTracker.h>
#include <XVWindowX.h>
#include <XVMpeg.h>
#ifdef HAVE_BTTV
#include <XVBt8x8.h>
#endif
#include <XVDig1394.h>
#include <iostream>

static u_short preferredHue = 0;
static u_short range = 2;

// choose your weapon

#define _EXSTEPPER_ XVTransStepper
#define _EXSTATE_ XVTransState
//#define _EXSTEPPER_ XVSE2Stepper
//#define _EXSTATE_   XVSE2State

int main(int argc, char * argv[]){

  typedef XVVideo<XVImageRGB<XV_RGB> > VID;
  typedef XVMpeg<XVImageRGB<XV_RGB> >  MPG;
//  typedef XVBt8x8<XVImageRGB<XV_RGB> > DIG;
  typedef XVDig1394<XVImageRGB<XV_RGB> > DIG;
  typedef XVInteractWindowX<XV_RGB >    WIN;
//   typedef XVRemoteWindowX<XV_RGB >    WIN;

  //  typedef XVSSD<XVImageScalar<int>, _EXSTEPPER_<XVImageScalar<int> > > SSD;
  // typedef XVSSD<XVImageRGB<XV_RGB>, _EXSTEPPER_<XVImageRGB<XV_RGB> > > SSD;
  typedef XVSSD<XVImageRGB<XV_RGB>, 
                XVPyramidStepper<XVTransStepper<XVImageRGB<XV_RGB> > > > SSD ;

  // pick your opponent
  // VID * vid = new MPG(argv[1]); 
  VID * vid = new DIG( "/dev/video1394", "S1R1" );

  // flush first image
  vid->next_frame_continuous();

  WIN win(vid->frame(0));
  win.map();
  
  SSD ssd;

  vid->next_frame_continuous();
  vid->next_frame_continuous();
  win.CopySubImage(vid->current_frame());
  win.swap_buffers();
  win.flush();


  XVROI roi( 80,60 );
  win.selectRectangle(roi); 
  XVImageRGB<XV_RGB> tmpl ;
  XVImageRGB<XV_RGB> tmpl1;
  // XVImageScalar<float> ftmpl;
  tmpl = subimage(vid->current_frame(), roi); 

  cout << "Got the image" << endl;
  // ssd.setInit(roi,tmpl);
  // XVTransStepper<XVImageRGB<XV_RGB> > SSDStepper(tmpl);

  ssd.setStepper(subimage(vid->current_frame(),roi));
  ssd.initState( (XVTransState)roi );

  cout << "Got here 1 " << endl;

  XVDisplayTracker<VID, WIN, SSD > tracker(*vid, win, ssd, 100);
  // tracker.init();

  cout << "Got here 2 " << endl;


  cout << "Got here 3 " << endl;


  // The SE2 (translation, rotation, and scale) SSD tracker
  // is intialized using the selectAngledRect function
  // which first expects a line to be selected by dragging the
  // mouse and releasing, and then selecting a rectangle
  // with the line as one side.  The box should be selected
  // in the downward direction from the line

  SSD::STATE st;// = tracker.init();
  XVTransState st1(50,50);// = tracker.init();

  XVWindowX<XV_RGB> warpWin(roi.Width(),roi.Height(), 400, 10);
  //  XVWindowX<XV_RGB> warpWinf(roi, 400, 10);

  cout << "Got here 3 " << endl;

  warpWin.map();
  //  warpWinf.map();

  cout << "Got here 4 " << endl;
  try {

    // can use simple track call, or complicated while loop

    // tracker.track();
    
    while(1){

      //      vid->next_frame_continuous();
      tmpl = subimage(vid->current_frame(), roi);
      for (int iii=1;iii<2;iii++) {
	st = tracker.nextState();
      ScalartoRGB(ssd.warpedImage(),tmpl1);
      warpWin.CopySubImage(tmpl1);
            warpWin.swap_buffers();
            warpWin.flush();
      }

      //SSDStepper.step(XVImageScalar<float>(tmpl),st1);

      // for a translation state
        // cout << st.state << "\t" << st.error << endl;

      // SE2 (rotation, translation, scale)
      /*      cout << st.state.angle << "\t" 
	   << st.state.scale << "\t"
	   << st.state.trans.PosX() << "\t"
	   << st.state.trans.PosY() << "\t" 
	   << st.error << endl;*/

      // displays the warped SSD image
      
	    //      RGBtoScalar(tmpl,ftmpl);
	    ScalartoRGB((XVImageScalar<float>)tmpl,tmpl1);
	    //      warpWinf.CopySubImage(tmpl1);
    }
  }catch(XVException te){ cout << te.what() << endl; };
};


